Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Geometry.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Geometry.h	(revision 2752)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Geometry.h	(revision 2755)
@@ -4,5 +4,5 @@
 #include "common.h"
 #include "AxisAlignedBox3.h"
-
+#include "Triangle3.h"
 
 
@@ -23,4 +23,7 @@
 	Geometry(const TriangleContainer &triangles);
 
+	int CountTriangles() const { return (int)mTriangles.size(); }
+
+
 protected:
 
@@ -35,4 +38,6 @@
 class SceneEntity
 {
+public:
+
 	/** Create scene entity.
 	*/
@@ -44,7 +49,10 @@
 	*/
 	void SetGeometry(Geometry *geom);
+	/** See set
+	*/
+	Geometry *GetGeometry() const { return mGeometry; }
 	/** Set pointer to the geometry
 	*/
-	void SetTransformation(const Matrix4x4 *trafo);
+	void SetTransformation(Matrix4x4 *trafo);
 	/** Set pointer to the material
 	*/
@@ -59,4 +67,5 @@
 	*/
 	int GetLastVisited() const;
+
 
 protected:
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/CHCTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/CHCTraverser.h	(revision 2755)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/CHCTraverser.h	(revision 2755)
@@ -0,0 +1,27 @@
+#ifndef __CHCTRAVERSER_H
+#define __CHCTRAVERSER_H
+
+#include "RenderTraverser.h"
+
+
+namespace CHCDemo
+{
+
+/** Class implementing traversal using the CHC algorithm.
+*/
+class CHCTraverser: public RenderTraverser
+{
+public:
+	CHCTraverser();
+	~CHCTraverser();
+
+	/** Renders the scene with the specified method
+	*/
+	virtual void Render();
+};
+
+}
+
+
+
+#endif // __CHCTRAVERSER_H
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Material.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Material.h	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Material.h	(revision 2755)
@@ -6,7 +6,10 @@
 {
 
+
 class RgbColor 
 {
+
 public:
+
   float r, g, b;
 
@@ -44,30 +47,19 @@
 {
 public:
+
   RgbColor mDiffuseColor;
   RgbColor mSpecularColor;
   RgbColor mAmbientColor;
   
-  Material(): mId(0)
-  {
-  }
+  Material();
   
-  Material(const int id): mId(id)
-  {
-  }
+  Material(const int id);
 
-  Material(const RgbColor &color):mDiffuseColor(color),
-								  mAmbientColor(color),
-								  mSpecularColor(0,0,0), mId(0)
-  {
-  }
-  
-  friend Material RandomMaterial();
-  
+  Material(const RgbColor &color);
   /** Returns unique material id.
   */
-  int GetId() const
-  {
-	  return mId;
-  }
+  int GetId() const;
+
+  friend Material RandomMaterial();
 
 protected:
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/CHCPlusPlusTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/CHCPlusPlusTraverser.h	(revision 2755)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/CHCPlusPlusTraverser.h	(revision 2755)
@@ -0,0 +1,27 @@
+#ifndef __CHCPLUSPLUSTRAVERSER_H
+#define __CHCPLUSPLUSTRAVERSER_H
+
+#include "RenderTraverser.h"
+
+
+namespace CHCDemo
+{
+
+/** Class implementing traversal using the CHC algorithm.
+*/
+class CHCPlusPlusTraverser: public RenderTraverser
+{
+public:
+	CHCPlusPlusTraverser();
+	~CHCPlusPlusTraverser();
+
+	/** Renders the scene with the specified method
+	*/
+	virtual void Render();
+};
+
+}
+
+
+
+#endif // __CHCTRAVERSER_H
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/BvhLoader.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/BvhLoader.h	(revision 2755)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/BvhLoader.h	(revision 2755)
@@ -0,0 +1,33 @@
+// This file has been written by Jiri Bittner, October 2006
+
+#ifndef __BVHLOADER_H
+#define __BVHLOADER_H
+
+#include "Bvh.h"
+
+
+namespace CHCDemo
+{
+
+/** Loader for a bounding volume hierarchy.
+*/
+class BvhLoader
+{
+public:
+
+	Bvh *LoadFromFile(const std::string &filename, const SceneEntityContainer &entities);
+
+protected:
+	
+	BvhLeaf *ImportBinLeaf(std::ifstream &stream, BvhInterior *parent);
+
+	BvhInterior *ImportBinInterior(std::ifstream &stream, BvhInterior *parent);
+
+	BvhNode *LoadNextNode(std::ifstream &stream, BvhInterior *parent);
+
+
+};
+
+}
+
+#endif // __BVHLOADER_H
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/RenderTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/RenderTraverser.cpp	(revision 2754)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/RenderTraverser.cpp	(revision 2755)
@@ -57,17 +57,29 @@
 }*/
 
-#if 0
-void RenderTraverser::TraverseNode(HierarchyNode *node)
-{
-	if(node->IsLeaf())
-		mNumRenderedGeometry += node->Render();
+void RenderTraverser::EnqueueNode(BvhNode *node)
+{
+	mBvh->CalcDistance(node);
+	mDistanceQueue.push(node);
+}
+
+
+void RenderTraverser::TraverseNode(BvhNode *node)
+{
+	if (node->IsLeaf())
+	{
+		//mNumRenderedGeometry += node->Render();
+	}
 	else 
 	{
 		// for non leafs this renders only the bounding volume (if the flag is set)
 		//node->Render();
-		mDistanceQueue.push(node->GetLeftChild());
-		mDistanceQueue.push(node->GetRightChild());
-	}
-}
+		BvhInterior *interior = static_cast<BvhInterior *>(node);
+
+		EnqueueNode(interior->GetFront());
+		EnqueueNode(interior->GetBack());
+	}
+}
+
+#if 0
 
 void RenderTraverser::RenderVisualization()
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp	(revision 2752)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp	(revision 2755)
@@ -1,21 +1,19 @@
 #include <queue>
 #include <stack>
-#include "Bvh.h"
-
 #include <fstream>
 #include <iostream>
 #include <iomanip>
 
+#include "Bvh.h"
+#include "Camera.h"
+#include "Plane3.h"
+#include "glInterface.h"
+#include "Triangle3.h"
+
 
 namespace CHCDemo
 {
 
-#if TOIMPLEMENT
-
 #define INVALID_TEST ((unsigned int)-1)
-
-#define TYPE_INTERIOR -2
-#define TYPE_LEAF -3
-#define USE_TIGHTER_BOUNDS_FOR_ALL 0
 
 const static bool useVbos = true;
@@ -62,4 +60,10 @@
 */
 
+static Plane3 sNearPlane;
+static Camera::Frustum sFrustum;
+
+/// these values are valid for all nodes
+static int sClipPlaneAABBVertexIndices[12];
+
 
 BvhNode::BvhNode(BvhNode *parent): 
@@ -69,5 +73,4 @@
 mPlaneMask(0),
 mPreferredPlane(0),
-mVizBox(NULL),
 mLastRenderedFrame(-999),
 mFirst(-1), 
@@ -75,5 +78,7 @@
 mNumTestNodes(1),
 mTestNodesIdx(-1),
-mIndicesPtr(-1)
+mIndicesPtr(-1),
+mIndices(NULL),
+mId(0)
 {
 }
@@ -83,5 +88,4 @@
 {
 	mVisibility.Reset();
-	mMeasurements.Reset();
 
 	mLastRenderedFrame = -999;
@@ -91,17 +95,4 @@
 BvhNode::~BvhNode() 
 {
-	if (mVizBox) mVizBox->unref();
-}
-
-
-Box *BvhNode::GetOrCreateVizBox() 
-{
-	if (!mVizBox) 
-	{
-		mVizBox = new Box(mBox); 
-		mVizBox->ref();
-	}
-
-	return mVizBox;
 }
 
@@ -110,34 +101,18 @@
 {
 	mIsVisible = false;
-	mIsFullyVisible = false;
-
-	mVisiblePixels = 0;
+	
 	mAssumedVisibleFrames = 0;
-	mRemainingVisibleFrames = 0;
 
 	mLastVisitedFrame = -1;
-	mLastTestedFrame = -1;
-	mTurnedVisibleFrame = 0;
-
+	
 	mTimesInvisible = 0;
-	mTimesTested = 0;
-	mTimesChangedClassification = 0;
-	mAvgChangedClassification = 0;
 	mIsFrustumCulled = false;
 
-	mLastTestedVisibleFrame = 0;
 	mIsNew = true;
 }
 
 
-void BvhNode::SetFullyVisible(const bool visible)
-{
-	mVisibility.mIsFullyVisible = visible;
-}
-
-
 BvhLeaf::~BvhLeaf()
 {
-	if (mTriangleBvh) delete mTriangleBvh;
 }
 
@@ -148,5 +123,15 @@
 
 
-
+Bvh::Bvh():
+mCamera(NULL), 
+mFrameId(-1), 
+mRoot(NULL), 
+mVertices(NULL),
+mIndices(NULL),
+mTestIndices(NULL),
+mCurrentIndicesPtr(0)
+{}
+
+/*
 Bvh::Bvh(const GeometryVector &geometry, 
 		 DistanceSortedRenderAction *const renderer):
@@ -156,9 +141,6 @@
 mVertices(NULL),
 mIndices(NULL),
-mUseTighterBoundsOnlyForLeafTests(false),
-mRenderer(renderer),
 mTestIndices(NULL),
 mCurrentIndicesPtr(0),
-mCollectTighterBoundsWithMaxLevel(true)
 {
 	mGeometry = new NodeGeometry*[geometry.size()];
@@ -203,10 +185,9 @@
 
 	mMaxDepthForTestingChildren = Settings::Global()->get_nvocc_bvh_max_depth_for_testing_children();
-	mUseTighterBoundsOnlyForLeafTests = (Settings::Global()->get_nvocc_use_tighter_bounds() >= 1);
-	
+		
 	mAreaRatioThreshold = Settings::Global()->get_nvocc_area_ratio_threshold();
 	mVolRatioThreshold = Settings::Global()->get_nvocc_vol_ratio_threshold();
 }
-
+*/
 
 Bvh::~Bvh() 
@@ -221,530 +202,4 @@
 
 
-void Bvh::Construct()
-{
-	PerfTimer constructTimer;
-	constructTimer.Entry();
-
-	OUT1("Info: Constructing BVH");
-
-	mRoot = SubdivideLeaf((BvhLeaf *)mRoot, 0);
-
-	constructTimer.Exit();
-
-	OUT1("Info: Bvh done in " << constructTimer.TotalCount() << " seconds.");
-	OUT1("Info: Number Of BVH Nodes = " << mNumNodes);
-
-	// update stats on leaf nodes
-	UpdateNumLeaves(mRoot);
-	
-	mAvgDepth = 1.0f + log((float)GetNumLeaves()) / log(2.0f);
-
-	BvhLeafContainer leaves;
-	leaves.reserve(GetNumLeaves());
-	CollectLeaves(mRoot, leaves);
-
-	// compute tighter boundaries for the leaves
-	PostProcessLeaves(leaves);
-	// compute unique ids
-	ComputeIds();
-	/// pull up some data from the leaves
-	UpdateInteriors(mRoot);
-	// recompute the boundaries once
-	RecomputeBounds();
-	// do stats
-	ComputeBvhStats();
-
-	PrintBvhStats();
-}
-
-
-float Bvh::EvaluateSahCost(BvhLeaf *leaf, const int axis, const float position)
-{
-	// count triangles on the left / right
-	int left = 0;
-	int right = 0;
-	BoundingBox leftBox, rightBox;
-
-	const int candidates = std::max(50, (int)(leaf->CountPrimitives() / 20));
-
-	const float finc = leaf->CountPrimitives() / (float)candidates;
-
-	int i = leaf->mFirst;
-	float fi = leaf->mFirst + 0.5f;
-
-	BoundingBox box;
-
-	for (; i <= leaf->mLast;) 
-	{
-		box = mGeometry[i]->GetBoundingBox();
-
-		if (box.getCenter()[axis] < position) 
-		{
-			++ left;
-			// update the box
-			leftBox.combine(&box);
-		} 
-		else 
-		{
-			++ right;
-			rightBox.combine(&box);
-		}
-		 
-		fi += finc;
-		i = (int)fi;
-	}
-
-	float bW = 1.0f;
-	float leftRatio = left / (float)leaf->CountPrimitives();
-	float rightRatio = right / (float)leaf->CountPrimitives();
-
-	float saLeft = 0.0f;
-	float saRight = 0.0f;
-
-	// not a valid split
-	if (!left || !right)
-		return 1e25f;
-
-	saLeft = leftBox.getSurface();
-	saRight = rightBox.getSurface();
-
-
-	return
-		saLeft  * ((1.0f - bW) + bW * leftRatio) + 
-		saRight * ((1.0f - bW) + bW * rightRatio);
-}
-
-
-float Bvh::SelectPlaneSah(BvhLeaf *leaf, int &axis, float &minCost)
-{
-	minCost = MAXFLOAT;
-	float bestPos = minCost;
-	int bestAxis = 0;
-
-	//  cout<<"Evaluating axis..."<<endl<<flush;
-
-	const int initialPlanes = 3;
-
-	// initiate the costs
-	for (axis = 0; axis < 3; ++ axis) 
-	{
-		const float size = leaf->mBox.getUpper()[axis] - leaf->mBox.getLower()[axis];
-
-		for (int i = 0; i < initialPlanes; ++ i) 
-		{
-			const float pos = leaf->mBox.getLower()[axis] + (i + 1) * size / (initialPlanes + 1);
-			const float cost = EvaluateSahCost(leaf, axis, pos);
-
-			if (cost < minCost) 
-			{
-				minCost = cost;
-				bestPos = pos;
-				bestAxis = axis;
-			}
-		}
-	}
-
-	axis = bestAxis;
-
-	//  cout<<axis<<endl<<flush;
-	const float shrink = 0.5f;
-
-	// now hierarchically refine the initial interval
-	float size = shrink * 
-		(leaf->mBox.getUpper()[axis] - leaf->mBox.getLower()[axis]) / (initialPlanes + 1);
-
-	const int steps = 4;
-	float cost;
-
-	for (int i = 0; i < steps; ++ i) 
-	{
-		const float left = bestPos - size;
-		const float right = bestPos + size;
-
-		cost = EvaluateSahCost(leaf, axis, left);
-
-		if (cost < minCost) 
-		{
-			minCost = cost;
-			bestPos = left;
-		}
-
-		cost = EvaluateSahCost(leaf, axis, right);
-
-		if (cost < minCost) 
-		{
-			minCost = cost;
-			bestPos = right;
-		}
-
-		size = shrink * size;
-	}
-
-	//OUT1("best axis: " << axis << " " << bestPos << " " << minCost);
-
-	return bestPos;
-}
-
-
-void Bvh::ResizeVisibilityBuffers(const int maxSize)
-{
-	std::stack<BvhNode *> nodeStack;
-
-	nodeStack.push(mRoot);
-
-	while (!nodeStack.empty()) 
-	{
-		BvhNode *node = nodeStack.top();
-		nodeStack.pop();
-
-		static_cast<BvhLeaf *>(node)->mMeasurements.Reset();
-
-		if (!node->IsLeaf()) 
-		{
-			BvhInterior *interior = static_cast<BvhInterior *>(node);
-			
-			nodeStack.push(interior->mBack);
-			nodeStack.push(interior->mFront);
-		}
-	}
-}
-
-
-int Bvh::SortTriangles(BvhLeaf *leaf, 
-					   const int axis, 
-					   const float position)
-{
-	int i = leaf->mFirst;
-	int j = leaf->mLast;
-
-    while (1) 
-	{
-		while (mGeometry[i]->GetBoundingBox().getCenter()[axis] < position) 
-			++ i;
-	
-		while (position < mGeometry[j]->GetBoundingBox().getCenter()[axis])
-			-- j;
-
-		if (i < j) 
-		{
-			std::swap(mGeometry[i], mGeometry[j]);
-			
-			++ i;
-			-- j;
-		}
-		else
-		{
-			break;
-		}
-	}
-
-	return j;
-}
-
-
-int Bvh::SortTrianglesSpatialMedian(BvhLeaf *leaf, const int axis)
-{
-	// spatial median
-	float x = leaf->mBox.getCenter()[axis];
-
-	return SortTriangles(leaf, axis, x);
-}
-
-
-int Bvh::SortTrianglesObjectMedian(BvhLeaf *leaf, const int axis, float &pos)
-{
-	// Now distribute the objects into the subnodes
-	// Use QuickMedian sort
-	int l = leaf->mFirst;
-	int r = leaf->mLast;
-	int k = (l + r) / 2;
-
-	while (l < r) 
-	{
-		int i = l;
-		int j = r;
-
-		// get some estimation of the pivot
-		pos = mGeometry[(l + r) / 2]->GetBoundingBox().getCenter()[axis];
-
-		while (1) 
-		{
-			while ((i  <= leaf->mLast) && (mGeometry[i]->GetBoundingBox().getCenter()[axis] < pos))
-				++ i;
-
-			while((j >= leaf->mFirst) && (pos < mGeometry[j]->GetBoundingBox().getCenter()[axis]))
-				-- j;
-
-			if (i <= j) 
-			{
-				std::swap(mGeometry[i], mGeometry[j]);
-				++ i;
-				-- j;
-			}
-			else
-			{
-				break;
-			}
-		}
-
-		// now check the extents
-		if (i >= k)
-			r = j;
-		else
-			l = i;
-	}
-
-	return k;
-}
-
-
-int Bvh::SortTrianglesSurfaceArea(BvhLeaf *leaf, const float sa)
-{
-	int i = leaf->mFirst;
-	int j = leaf->mLast;
-
-	while(1) 
-	{
-		while ((i <= j) && (mGeometry[i]->GetBoundingBox().getSurface() < sa)) 
-			++ i;
-
-		while ((i <= j) && (sa < mGeometry[j]->GetBoundingBox().getSurface()))
-			-- j;
-
-		if (i < j) 
-		{
-			swap(mGeometry[i], mGeometry[j]);
-			++ i;
-			-- j;
-		}
-		else
-			break;
-	}
-
-	return j;
-}
-
-
-bool Bvh::TerminationCriteriaMet(BvhLeaf *leaf) const
-{
-	const bool terminationCriteriaMet = 
-		(leaf->mBox.getSurface() < mMinArea) ||
-		(leaf->CountPrimitives() <= mMaxGeometry) ||
-		(CountTriangles(leaf) <= mMaxTriangles) ||
-		(leaf->mDepth > mMaxDepth);
-
-	return terminationCriteriaMet;
-}
-
-
-BvhNode *Bvh::SubdivideLeaf(BvhLeaf *leaf, const int parentAxis)
-{
-	if (TerminationCriteriaMet(leaf))
-		return leaf;
-	
-	//int axis = leaf->mBox.MajorAxis();
-	int axis = (parentAxis + 1) % 3;
-
-	// position of the split in the partailly sorted array of triangles
-	// corresponding to this leaf
-	int split = -1;
-	const int scale = 20;
-
-	float pos = -1.0f;
-
-	// Spatial median subdivision
-	switch (mSplitType) 
-	{
-	case SPATIAL_MEDIAN:
-		split = SortTrianglesSpatialMedian(leaf, axis);
-
-		if ( 
-			((split - leaf->mFirst) < leaf->CountPrimitives() / scale) ||
-			((leaf->mLast - split) < leaf->CountPrimitives() / scale) ) 
-		{
-			split = SortTrianglesObjectMedian(leaf, axis, pos);
-		}
-
-		pos = leaf->mBox.getCenter()[axis];
-		break;
-	case OBJECT_MEDIAN:
-		// Object median subdivision: approximately the same number
-		// of objects on the left of the the splitting point.
-		split = SortTrianglesObjectMedian(leaf, axis, pos);
-		break;
-	case SAH:
-		{
-			float cost;
-			pos = SelectPlaneSah(leaf, axis, cost);
-
-			if (pos != MAXFLOAT)
-			{
-				split = SortTriangles(leaf, axis, pos);
-			}
-
-			if ((pos == MAXFLOAT) || (split == leaf->mLast))
-			{
-				split = -1;
-				split = SortTrianglesObjectMedian(leaf, axis, pos);
-			}
-		}
-		break;
-	case SAH_OR_SIZE: 
-		{
-			// split by size instead
-			const float saThreshold = 0.2f * leaf->GetBox().getSurface();
-			split = SortTrianglesSurfaceArea(leaf, saThreshold);
-
-			if ((split == leaf->mLast) || (split == leaf->mFirst - 1)) 
-			{
-				// use SAH
-				float cost;
-				pos = SelectPlaneSah(leaf, axis, cost);
-
-				if (pos != MAXFLOAT)
-					split = SortTriangles(leaf, axis, pos);
-				else
-					split = SortTrianglesObjectMedian(leaf, axis, pos);
-			}
-			else
-			{
-				// note: no position is computed!!
-				//OUT1("sorted by size");
-			}
-		}
-		break;
-	default:
-		OUT1("should not come here");
-		break;
-	}
-
-	if (1 && ((split == leaf->mLast)))
-	{
-		// no reduction: we should never come here
-		OUT1("error: no reduction " << leaf->CountPrimitives() << " " << leaf->mFirst << " " << split << " " << leaf->mLast);
-		return leaf;
-	}
-
-	// create two more nodes
-	mNumNodes += 2;
-	BvhInterior *parent = new BvhInterior(leaf->GetParent());
-	BvhLeaf *front = new BvhLeaf(parent);
-	
-	parent->mAxis = axis;
-	parent->mBox = leaf->mBox;
-	parent->mDepth = leaf->mDepth;
-
-	parent->mBack = leaf;
-	parent->mFront = front;
-	parent->mPosition = pos;
-	
-	// now assign the triangles to the subnodes
-	front->mFirst = split + 1;
-	front->mLast = leaf->mLast;
-	front->mDepth = leaf->mDepth + 1;
-	leaf->mLast = split;
-	leaf->mDepth = front->mDepth;
-	leaf->mParent = parent;
-	
-	// reset box
-	leaf->mBox = BoundingBox();
-
-	UpdateLeafBox(static_cast<BvhLeaf *>(parent->mBack));
-	UpdateLeafBox(static_cast<BvhLeaf *>(parent->mFront));
-
-	// some output
-	const int n = 500;
-	if ((GetNumLeaves() % n) == n - 1)
-		OUT1("created " << GetNumLeaves() << " leaves");
-	
-#if VERBOSE_OUTPUT
-	OUT1("box: " << parent->mBox.getUpper() << " " << parent->mBox.getLower());
-	OUT1("depth: " << (int)parent->mDepth);
-	OUT1("axis: " << axis);
-	OUT1("bc="<<((BvhLeaf *)parent->mBack)->Count());
-	OUT1("fc="<<((BvhLeaf *)parent->mFront)->Count());
-	OUT1("back: " << parent->mBack->mBox.getSurface());
-	OUT1("front: " << parent->mFront->mBox.getSurface());
-#endif
-
-	// recursively continue subdivision
-	parent->mBack = SubdivideLeaf(static_cast<BvhLeaf *>(parent->mBack), axis);
-	parent->mFront = SubdivideLeaf(static_cast<BvhLeaf *>(parent->mFront), axis);
-
-	return parent;
-}
-
-
-void Bvh::UpdateLeafBox(BvhLeaf *leaf)
-{
-	for (int i = leaf->mFirst; i <= leaf->mLast; ++ i) 
-	{
-		leaf->mBox.combine(&mGeometry[i]->mBox);
-	} // for
-}
-
-
-void Bvh::UpdateNumLeaves(BvhNode *node) const
-{
-	if (node->IsLeaf())
-	{
-		node->mNumLeaves = 1;
-	}
-	else
-	{
-		BvhNode *f = static_cast<BvhInterior *>(node)->GetFront();
-		BvhNode *b = static_cast<BvhInterior *>(node)->GetBack();
-
-		UpdateNumLeaves(f);
-		UpdateNumLeaves(b);
-
-		node->mNumLeaves = f->mNumLeaves + b->mNumLeaves;
-	}
-}
-
-
-void Bvh::UpdateBoxes(BvhNode *node)
-{
-	if (node->IsLeaf()) 
-	{
-		UpdateLeafBox(static_cast<BvhLeaf *>(node));
-	}
-	else 
-	{
-		BvhInterior *interior = static_cast<BvhInterior *>(node);
-	
-		UpdateBoxes(interior->mBack);
-		UpdateBoxes(interior->mFront);
-
-		node->mBox = interior->mBack->mBox;
-		node->mBox.combine(&interior->mFront->mBox);
-	}
-}
-
-
-void Bvh::UpdateFullVisibility(BvhNode *node) const
-{		
-	// node not visited in this frame => no change
-	if (node->GetLastVisitedFrame() != mFrameId) 
-		return;
-
-	// leaf node: terminate recursion
-	if (node->IsLeaf())
-	{
-		node->SetFullyVisible(node->IsVisible());	
-		return;
-	}
-
-	BvhInterior *interior = static_cast<BvhInterior *>(node);
-	
-	// recursive traversal
-	UpdateFullVisibility(interior->mBack);
-	UpdateFullVisibility(interior->mFront);
-	
-	interior->SetFullyVisible(interior->mBack->IsFullyVisible() && 
-							  interior->mFront->IsFullyVisible());
-}
-
-
 void Bvh::PullUpLastVisited(BvhNode *node, const int frameId) const
 {		
@@ -823,7 +278,5 @@
 typedef pair<BvhNode *, int> tPair;
 
-void Bvh::CollectNodes(BvhNode *root, 
-					   const int depth, 
-					   HierarchyNodeContainer &nodes)
+void Bvh::CollectNodes(BvhNode *root, BvhNodeContainer &nodes, int depth)
 {
 	stack<tPair> tStack;
@@ -838,25 +291,9 @@
 
 		// found depth => take this node
-		if (d == depth)
+		if ((d == depth) || (node->IsLeaf()))
 		{
 			nodes.push_back(node);
 		}
-		else if (node->IsLeaf())
-		{
-			// found leaf
-			BvhLeaf *leaf = static_cast<BvhLeaf *>(node);
-
-			// there is no further subdivision on triangle level
-			if (leaf->mTriangleBvh->GetNumNodes() == 1)
-			{
-				nodes.push_back(leaf);
-			}
-			else // more than a root => search in local bvh
-			{
-				leaf->mTriangleBvh->
-					CollectNodes(leaf->mTriangleBvh->GetRoot(), depth - d, nodes);
-			}
-		}
-		else // interior
+		else
 		{
 			BvhInterior *interior = static_cast<BvhInterior *>(node);
@@ -869,143 +306,5 @@
 
 
-void Bvh::CollectAllNodes(BvhNode *node, HierarchyNodeContainer &nodes)
-{
-	BvhNodeContainer bvhNodes;
-
-	// collect nodes of geometry bvh
-	CollectNodes(mRoot, bvhNodes);
-
-	
-	// first collect nodes of object bvh
-	BvhNodeContainer::const_iterator lit, lit_end = bvhNodes.end();
-
-	for (lit = bvhNodes.begin(); lit != lit_end; ++ lit)
-	{
-		nodes.push_back(*lit);
-	}
-
-	// collect nodes of local bvh: all except roots, 
-	// because they are equivalent to geometry bvh leaves
-	for (lit = bvhNodes.begin(); lit != lit_end; ++ lit)
-	{
-		if ((*lit)->IsLeaf())
-		{
-			BvhLeaf *leaf = static_cast<BvhLeaf *>(*lit);
-
-			TriangleBvhNodeContainer hnodes;
-			leaf->mTriangleBvh->CollectNodes(leaf->mTriangleBvh->GetRoot(), hnodes);
-
-			TriangleBvhNodeContainer::const_iterator hit, hit_end = hnodes.end();
-
-			for (hit = hnodes.begin(); hit != hit_end; ++ hit)
-			{
-				TriangleBvhNode *n = *hit;
-
-				// don't include root of local bvh - it has the same bounds as the leaves
-				if (n != leaf->mTriangleBvh->GetRoot())
-					nodes.push_back(n);
-			}
-		}
-	}
-}
-
-
-void Bvh::CollectVisibleLeaves(BvhNode *node, BvhLeafContainer &leaves)
-{
-	stack<BvhNode *> tStack;
-	tStack.push(node);
-
-	while (!tStack.empty())
-	{
-		BvhNode *node = tStack.top();
-		tStack.pop();
-
-		if (IsWithinViewFrustum(node))
-		{
-			if (!node->IsLeaf())
-			{
-				BvhInterior *interior = static_cast<BvhInterior *>(node);
-
-				tStack.push(interior->mFront);
-				tStack.push(interior->mBack);
-			}
-			else
-			{
-				leaves.push_back(static_cast<BvhLeaf *>(node));
-			}
-		}
-	}
-}
-
-
-BvhLeaf *Bvh::GetRandomLeaf(BvhNode *node)
-{
-	stack<BvhNode *> nodeStack;
-  
-	nodeStack.push(node);
-
-	int mask = rand();
-
-    while (!nodeStack.empty()) 
-	{
-		BvhNode *node = nodeStack.top();
-		nodeStack.pop();
-		
-		if (node->IsLeaf()) 
-		{
-			// random leaf
-			return static_cast<BvhLeaf *>(node);
-		} 
-		else 
-		{
-			BvhInterior *interior = static_cast<BvhInterior *>(node);
-			
-			BvhNode *next;
-			
-			// random decision
-			if (mask & 1)
-				next = interior->mBack;
-			else
-				next = interior->mFront;
-
-			mask = mask >> 1;
-
-			nodeStack.push(next);
-		}
-	}
-  
-	// should never come here
-	return NULL;
-}
-
-
-BvhLeaf *Bvh::GetRandomVisibleLeaf(BvhNode *node)
-{
-	BvhLeafContainer leaves;
-	leaves.reserve(node->GetNumLeaves());
-
-	CollectVisibleLeaves(node, leaves);
-
-	if (leaves.empty())
-		return NULL;
-
-	const int r = (int)(((float)rand() / RAND_MAX) * ((float)leaves.size() - 0.5f));
-
-	return leaves[r];
-}
-
-
-void Bvh::CollectGeometry(BvhNode *node, GeometryVector &geometry)
-{
-	//geometry.reserve(node->CountPrimitives());
-
-	for (int i = node->mFirst; i <= node->mLast; ++ i)
-	{
-		geometry.push_back(mGeometry[i]);
-	}
-}
-
-
-NodeGeometry **Bvh::GetGeometry(BvhNode *node, int &geometrySize)
+SceneEntity **Bvh::GetGeometry(BvhNode *node, int &geometrySize)
 {
 	geometrySize = node->CountPrimitives();
@@ -1014,24 +313,5 @@
 
 
-void Bvh::UpdateInteriors(BvhNode *node)
-{
-	if (!node->IsLeaf())
-	{
-		BvhInterior *interior = static_cast<BvhInterior *> (node);
-		
-		// update the indices of the geometry so we can render interiors as well
-		UpdateInteriors(interior->GetBack());
-		UpdateInteriors(interior->GetFront());
-
-		// update area
-		interior->mFirst = min(interior->GetBack()->mFirst, interior->GetFront()->mFirst);
-		interior->mLast = max(interior->GetBack()->mLast, interior->GetFront()->mLast);
-	
-		interior->mArea = interior->GetBack()->mArea + interior->GetFront()->mArea;
-	}
-}
-
-
-int	Bvh::IsWithinViewFrustumLocal(BvhNode *node)
+int	Bvh::IsWithinViewFrustum(BvhNode *node)
 {
 	bool bIntersect	= false;
@@ -1050,5 +330,5 @@
 		{
 			//-- test the n-vertex
-			if (node->mBox.getDistance(mClipPlaneAABBVertexIndices[i][0], mFrustum.mClipPlane[i]) > 0.0f)
+			if (node->mBox.GetDistance(sClipPlaneAABBVertexIndices[i * 2 + 0], sFrustum.mClipPlanes[i]) > 0.0f)
 			{
 				//-- outside
@@ -1058,5 +338,5 @@
 
 			//-- test the p-vertex
-			if (node->mBox.getDistance(mClipPlaneAABBVertexIndices[i][1], mFrustum.mClipPlane[i]) <= 0.0f)
+			if (node->mBox.GetDistance(sClipPlaneAABBVertexIndices[i * 2 + 1], sFrustum.mClipPlanes[i]) <= 0.0f)
 			{
 				//-- completely inside: children don't need to check against this plane no more
@@ -1079,5 +359,5 @@
 		{
 			//-- test the n-vertex
-			if (node->mBox.getDistance(mClipPlaneAABBVertexIndices[i][0], mFrustum.mClipPlane[i]) > 0.0f)
+			if (node->mBox.GetDistance(sClipPlaneAABBVertexIndices[i * 2 + 0], sFrustum.mClipPlanes[i]) > 0.0f)
 			{
 				// outside
@@ -1087,5 +367,5 @@
 
 			//-- test the p-vertex
-			if (node->mBox.getDistance(mClipPlaneAABBVertexIndices[i][1], mFrustum.mClipPlane[i]) <= 0.0f)
+			if (node->mBox.GetDistance(sClipPlaneAABBVertexIndices[i * 2 + 1], sFrustum.mClipPlanes[i]) <= 0.0f)
 			{
 				// completely inside: children don't need to check against this plane no more
@@ -1103,101 +383,5 @@
 
 
-int	Bvh::IsWithinViewFrustum(const BoundingBox &box, const int planeMask, const int preferredPlane)
-{
-	bool bIntersect	= false;
-
-	////////
-	//-- do the view frustum culling for the planes [mPreferredPlane - 5]
-
-	for (int i = preferredPlane; i < 6; ++ i)
-	{
-		//-- do the test only if necessary
-		if (planeMask & (1 << i))
-		{
-			//-- test the n-vertex
-			if (box.getDistance(mClipPlaneAABBVertexIndices[i][0], mFrustum.mClipPlane[i]) > 0.0f)
-				return 0;
-
-			//-- test the p-vertex
-			if (!(box.getDistance(mClipPlaneAABBVertexIndices[i][1], mFrustum.mClipPlane[i]) <= 0.0f))
-				bIntersect = true;
-		}
-	}
-
-	//////////
-	//-- do the view frustum culling for the planes [0 - m_iPreferredPlane)
-
-	for (int i = 0; i < preferredPlane; ++ i)
-	{
-		// do the test only if necessary
-		if (planeMask & (1 << i))
-		{
-			//-- test the n-vertex
-			if (box.getDistance(mClipPlaneAABBVertexIndices[i][0], mFrustum.mClipPlane[i]) > 0.0f)
-				// outside
-				return 0;
-
-			//-- test the p-vertex
-			if (!(box.getDistance(mClipPlaneAABBVertexIndices[i][1], mFrustum.mClipPlane[i]) <= 0.0f))
-				bIntersect = true;
-		}
-	}
-
-	return bIntersect ? -1 : 1;
-}
-
-
-int	Bvh::IsWithinViewFrustum(BvhNode *node)
-{
-	if (node->mCache.mLastFrustumTestedFrameId == mFrameId)
-	{
-		return node->mCache.mFrustumCulled;
-	}
-
-	node->mCache.mLastFrustumTestedFrameId = mFrameId;
-
-	timeViewFrustumCulling.Entry();
-	
-	if (Settings::Global()->get_nvocc_use_tighter_bounds_for_frustum_culling())
-	{
-		const int intersect = IsWithinViewFrustumLocal(node);
-
-		if ((node->mNumTestNodes == 1) || (intersect != -1))
-		{
-			//OUT1("x");
-			node->mCache.mFrustumCulled = intersect;
-		}
-		else 
-		{
-			// maybe intersecting one of the tighter boxes
-			node->mCache.mFrustumCulled = 0;
-
-			for (int i = 0; i < node->mNumTestNodes; ++ i)
-			{
-				RenderableHierarchyNode *n = mTestNodes[node->mTestNodesIdx + i];
-
-				if (IsWithinViewFrustum(n->GetBox(), 
-										node->mPlaneMask, 
-										node->mPreferredPlane))
-				{
-					node->mCache.mFrustumCulled = -1;
-					break;
-				}
-			}
-		}
-	}
-	else
-	{
-		//OUT1("y");
-		node->mCache.mFrustumCulled = IsWithinViewFrustumLocal(node);
-	}
-
-	timeViewFrustumCulling.Exit();
-
-	return node->mCache.mFrustumCulled;
-}
-
-
-void Bvh::InitFrame(Camera *camera, const int currentFrameId, Viewer *viewer)
+void Bvh::InitFrame(Camera *camera, int currentFrameId)
 {
 	// = 0011 1111 which means that at the beginning, all six planes have to frustum culled
@@ -1207,65 +391,10 @@
 	mFrameId = currentFrameId;
 
-	// to begin with, we must grab the plane equations of the six clipplanes of the viewfrustum
-	Matrix4f matViewing, matProjectionView;
-	Transform3D	transform;
-
-	camera->GetTransform(transform);
-	transform.get(matViewing);
-
-	camera->GetProjectionMatrix(matProjectionView);
-	matProjectionView *= matViewing;
-
-	Vec3f vec;
-	float fInvLength;
-
-
-	//////////
-	//-- extract the plane equations
-
-	for (int i = 0; i < 4; ++ i)
-	{
-		mFrustum.mClipPlane[0][i] = matProjectionView[i][3] - matProjectionView[i][0];	// right plane
-		mFrustum.mClipPlane[1][i] = matProjectionView[i][3] + matProjectionView[i][0];	// left plane
-		mFrustum.mClipPlane[2][i] = matProjectionView[i][3] + matProjectionView[i][1];	// bottom plane
-		mFrustum.mClipPlane[3][i] = matProjectionView[i][3] - matProjectionView[i][1];	// top plane
-		mFrustum.mClipPlane[4][i] = matProjectionView[i][3] - matProjectionView[i][2];	// far plane
-		mFrustum.mClipPlane[5][i] = matProjectionView[i][3] + matProjectionView[i][2];	// near plane
-	}
-
-	////////////
-	//-- normalize the coefficients and find the indices of the n- and p-vertices
-
-	for (int i = 0; i < 6; ++ i)
-	{
-		// the clipping planes look outward the frustum,
-		// so distances > 0 mean that a point is outside
-		fInvLength	= -1.0f / sqrt(	mFrustum.mClipPlane[i][0] * mFrustum.mClipPlane[i][0] +	
-									mFrustum.mClipPlane[i][1] * mFrustum.mClipPlane[i][1] +	
-									mFrustum.mClipPlane[i][2] * mFrustum.mClipPlane[i][2]);
-
-		mFrustum.mClipPlane[i][0] *= fInvLength;
-		mFrustum.mClipPlane[i][1] *= fInvLength;
-		mFrustum.mClipPlane[i][2] *= fInvLength;
-		mFrustum.mClipPlane[i][3] *= fInvLength;
-
-		vec.x = mFrustum.mClipPlane[i][0];
-		vec.y = mFrustum.mClipPlane[i][1];
-		vec.z = mFrustum.mClipPlane[i][2];
-
-		// n-vertex
-		mClipPlaneAABBVertexIndices[i][0] = BoundingBox::getIndexNearestVertex(vec);
-		// p-vertex
-		mClipPlaneAABBVertexIndices[i][1] = BoundingBox::getIndexFurthestVertex(vec);	
-	}
-
-
-	const float aspect = mCamera->GetAspect();
-	const float fov = mCamera->GetFov();
-	
-	mScale = sqrt(aspect) * 2.0f * tan(fov * mypi / 180.0f);
-
-	mNearPlane = mCamera->GetRealViewDirection();
-	mNearPlaneD = - mNearPlane * (mCamera->GetPosition() - Origin3f);
+	mCamera->CalcFrustum(sFrustum);
+	sFrustum.CalcNPVertexIndices(sClipPlaneAABBVertexIndices);
+
+	// calc near plane
+	sNearPlane = Plane3(mCamera->GetDirection(), 
+		                -mCamera->GetDirection() * mCamera->GetPosition());
 }
 
